/*
 * generated by Xtext
 */
package com.datastax.devcenter.json.formatting2

import com.datastax.devcenter.json.json.JsonArray
import com.datastax.devcenter.json.json.JsonArrayValue
import com.datastax.devcenter.json.json.JsonDocument
import com.datastax.devcenter.json.json.JsonMember
import com.datastax.devcenter.json.json.JsonObject
import com.datastax.devcenter.json.json.JsonObjectValue
import com.datastax.devcenter.json.json.JsonValue
import com.datastax.devcenter.json.services.JsonGrammarAccess
import com.google.inject.Inject
import org.eclipse.emf.ecore.EObject
import org.eclipse.xtext.formatting2.AbstractFormatter2
import org.eclipse.xtext.formatting2.IFormattableDocument

class JsonFormatter extends AbstractFormatter2 {
	
	@Inject extension JsonGrammarAccess

	def dispatch void format(JsonDocument jsonDocument, extension IFormattableDocument document) {
		// TODO: format HiddenRegions around keywords, attributes, cross references, etc. 
		for (EObject topLevelObjects : jsonDocument.getTopLevelObjects()) {
			format(topLevelObjects, document);
		}
	}

	def dispatch void format(JsonObject jsonObject, extension IFormattableDocument document) {
		// TODO: format HiddenRegions around keywords, attributes, cross references, etc. 
		for (JsonMember members : jsonObject.getMembers()) {
			format(members, document);
		}
	}

	def dispatch void format(JsonMember jsonMember, extension IFormattableDocument document) {
		// TODO: format HiddenRegions around keywords, attributes, cross references, etc. 
		format(jsonMember.getKey(), document);
		format(jsonMember.getValue(), document);
	}

	def dispatch void format(JsonObjectValue jsonObjectValue, extension IFormattableDocument document) {
		// TODO: format HiddenRegions around keywords, attributes, cross references, etc. 
		format(jsonObjectValue.getValue(), document);
	}

	def dispatch void format(JsonArrayValue jsonArrayValue, extension IFormattableDocument document) {
		// TODO: format HiddenRegions around keywords, attributes, cross references, etc. 
		format(jsonArrayValue.getValue(), document);
	}

	def dispatch void format(JsonArray jsonArray, extension IFormattableDocument document) {
		// TODO: format HiddenRegions around keywords, attributes, cross references, etc. 
		for (JsonValue value : jsonArray.getValue()) {
			format(value, document);
		}
	}
}
